Subject: Re: [PATCH net-next v3 0/7] switchdev: add IPv4 routing offload

From: John Fastabend <[email-masked]>
Date: Wed, 04 Mar 2015 23:18:52 -0800

On 03/04/2015 01:06 PM, David Miller wrote:
> From: Scott Feldman <[email-masked]>
> Date: Tue, 3 Mar 2015 23:28:06 -0800
>
>> On Tue, Mar 3, 2015 at 9:38 PM, David Miller <[email-masked]> wrote:
>> In v3, the setting and clearing of RTNH_F_EXTERNAL moved to the
>> driver, the implementer of the add/del ndo ops.  So RTNH_F_EXTERNAL
>> does get cleared by the driver on fib_flush_external().  We could add
>> an additional clear above the driver, just in case the driver screwed
>> up and forgot to clear it.  Driver bug in that case; not sure where to
>> draw the line.
>
> I'd rather the state bit get managed by net/ipv4/*.c rather than
> duplicate this into every driver, that's error prone and duplicates
> logic unnecessarily.
>
>>> Secondly, if you call fib_flush_external() because an add returned an
>>> error, you have to set some boolean state which prevents the next new
>>> route insert from loading only that new route into the hardware
>>> because that's exactly what will happen with your current
>>> implementation.
>>
>> I guess we could add a net.ipv4.fib_hw_screwed.  But that kills other
>> innocent switch devices on same netns.  Or is it a private driver
>> bool, which gets set on first install err, and is checked on
>> subsequent installs?
>
> You can make it per-netdevice if you want.  Put it into the inetdevice
> area perhaps.

Also at some point we will need a way to get it out of the
fib_hw_screwed state. But I guess we can lump this into the "better
policy" later.

Sorry for the noise on the last post...

.John

-- 
John Fastabend         Intel Corporation